#include "musiclibrary.h"
#include "ui_musiclibrary.h"
#include "musiclibrarybuilder.h"
#include "musiclibrarymodel.h"

MusicLibrary::MusicLibrary(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MusicLibrary)
{
    ui->setupUi(this);

    // Build a music library
    MusicLibrary *library = MusicLibraryBuilder::build(this);

    // Create a library model object
    MusicLibraryModel *model = new MusicLibraryModel(library);

    // Tree model of all objects
    QAbstractItemModel *treeModel = model->tree();

    // List of artists, records and songs
    QAbstractItemModel *artistListModel = model->artists();
    QAbstractItemModel *recordListModel = model->records();
    QAbstractItemModel *songLisgModel = model->songs();
}

MusicLibrary::~MusicLibrary()
{
    delete ui;
}

void MusicLibrary::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}
